$INTERFACE UA2SP2                                             97/12/01
  $SUBST('UZASET')
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $HELP
    EXPONENT IN SUM OF POWERS
  $CHECK(REXP,'2.0$P 0',REAL,2)
  $ADD(REAL,'\$GA($NF)\$G($NF)\$H($NF*($NF+1)/2)\$S($NF)')
$REM  $ADD(REAL,'\FA\F')
$REM  $ADD(INTEGER,'\NF\NA\NAL\KA\IVAR\INF')
 $00  CALL UA2SP2(NF,NA,NAL,KA,$GA,$G,$S,$H,FA,F,$REXP,IVAR,INF)
      GO TO ($60,$10,$20,$50) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $SUBST('UALNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<$NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $00
          $ELSEIF(FMODA='F')
            $SUBST('UA0G$(CON)1')
            GO TO ($00,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $20
          $ELSE
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $SUBST('UYTR$(CONSTR)A')
      GO TO $00
 $60  CONTINUE
      IF (IVAR.GT.0) THEN
      $IF(DECOMP='R')
      CALL UXDTGF(N,INF,$H,$S,ETA2)
      NDECF=NDECF+1
      IDECF=2
      IDECA=5
      $ELSEIF(DECOMP='C')
      $ADD(REAL,'\$SO($NF)')
      CALL UXDTGC(N,INF,$H,$IH,$S,$SO,ETA2)
      NDECF=NDECF+1
      IDECF=5
      IDECA=6
      $ELSEIF(DECOMP='T')
      $ADD(REAL,'\$SO($NF)')
      CALL UXDTGC(N,INF,$H,$IH,$S,$SO,ETA2)
      NDECF=NDECF+1
      IDECF=5
      IDECA=6
      $ENDIF
      ENDIF
      $ADD(INIT)
        NAXX='UA2SP2'
      $ENDADD
      $EXIT
