$INTERFACE UCESS1                                             98/12/01
  $HELP
    MAXIMUM BANDWITH OF THE CONSTRAINT PRECONDITIONER
  $CHECK(IBAN,NC,INT,2,NO)
  $DEFAULT=0
  $IF(IBAN='$NC') $DEFAULT=10
  $HELP
    MAXIMUM NUMBER OF DENSE ROWS:
  $CHECK(MD,DEFAULT,INT,2,NO)
  $HELP
    MINIMUM NUMBER OF NONZERO ELEMENTS IN A SPARSE ROWS:
  $CHECK(MDE,50,INT,2,NO)
  $HELP
    NUMBER OF NONZERO ELEMENTS IN THE PRECONDITIONER:
  $CHECK(MMAX,'20*$MC',INT,2)
  $IF(MD=0)
    $SB='UCESS1'
    CALL UCESS1(NC,MC,$MMAX,$IB,$JB,$ICG,$JCG,$IBAN)
    $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)\$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NC\MC\MMAX')
  $ELSE
    $BD='BD'
    $KCG='KCG'
    $SB='UCESD1'
    CALL UCESD1(NF,NC,MC,$MMAX,ND,$MD,$MDE,$IB,$JB,$ICG,$JCG,$KCG&
,ITERM)
    WRITE(3,'(''NUMBER OF DENSE COLUMNS:    ND  ='',I8)') ND
    $ADD(INTEGER,'\$IB($NC+1)\$JB($MMAX)\$ICG($NC+1)\$JCG($MC)&
    \$KCG($NF)')
    $ADD(REAL,'\$BD($MD*($MD+1)/2)')
$REM  $ADD(INTEGER,'\NF\NC\MC\MMAX\ND\ITERM')
  $ENDIF
  IF ($IB(NC+1)-1.GT.$MMAX) THEN
  CALL UOERR2('$SB',97,$IB(NC+1)-1,$MMAX)
  CALL UOERR4
  ITERM=-97
  ENDIF
  $EXIT
