$INTERFACE UDDEQ3                                             99/12/01
$REM LU
    $CON1='2.0$P-1'
    $CON2='1.0$P 1'
    $HELP
      MAXIMUM NUMBER OF EXTRAPOLATIONS OR INTERPOLATIONS
    $CHECK(MRED,20,INT,4)
    $HELP
      TOLERANCE FOR NONSINGULARITY
    $CHECK(ETA2,'ETA0*ETA0',REAL,4)
    $ADD(REAL,'\$X($NF)\$S($NF)\$AF($NA)\$AG($NF*$NA)')
    $ADD(REAL,'\TOL\UXVMAX')
    $ADD(INTEGER,'\$IA($NA)')
    $ADD(INTEGER,'\I')
    $DECOMP='E'
    $ISNA=3
    $ADD(INIT)
      ISNA=3
    $ENDADD
    $N='N'
    NRED=0
$20 NRED=NRED+1
    IF (NRED.GT.MRED) THEN
    ITERM=-6
    TXFU='MAX INT.'
    CALL UOERR1('UDDEQ3',6)
    GO TO $90
    END IF
    CALL UYSET2
    KD=0
    ASSIGN $40 TO IMD
$30 CONTINUE
    $KD=0
    $SUBST('UZMODL')
    GO TO IMD
$40 CONTINUE
    IF (F.GT.FO*(ONE-$CON1*R)) THEN
    R=HALF*R
    CALL UXVDIR($N,R,$S,$X,$X)
    GO TO $20
    ENDIF
    FO=F
    IF (FO.LT.TOLB) THEN
    ITERM=3
    TXFU='FV BOUND'
    GO TO $90
    ENDIF
    KD=1
    ASSIGN $50 TO IMD
    GO TO $30
$50 CONTINUE
    TOL=$ETA2
    CALL UXVCOP($N,$AF,$S)
    $JOB=0
    $IF(LAPACK='YES')
      $IF (JASA='R') $JOB=1
      CALL UXDGLF($N,$AG,$IA,INF,TOL)
      CALL UXDGLB($N,$AG,$IA,$S,$JOB)
    $ELSE
      $IF (JASA='C') $JOB=1
      CALL UXDGGF($N,$AG,$IA,INF,TOL)
      CALL UXDGGB($N,$AG,$IA,$S,$GA,$JOB)
    $ENDIF
    NDECA=NDECA+1
    IDECA=2
    R=MIN(1.0D0,XMAX/UXVMAX($N,$S))
    CALL UXVDIR($N,-R,$S,$X,$X)
    DMAX=ZERO
    DO $70 I=1,NF
    IF (NORMF.GT.0) THEN
    DMAX=MAX(DMAX,ABS(R*$S(I))/MAX(ABS($X(I)),$XN(I)))
    ELSE
    DMAX=MAX(DMAX,ABS(R*$S(I))/MAX(ABS($X(I)),ONE))
    ENDIF
$70 CONTINUE
$90 CONTINUE
    KD=0
    $ADD(INIT)
      NDXX='UDDEQ3'
    $ENDADD
$EXIT
