$INTERFACE UEVEX1                                             98/12/01
  $IES='IES'
  $MED1=1
  $HELP
    STEP SELECTION
      1 - STEP SELECTION FROM LOCAL TRUNCATION ERROR
      2 - STEP SELECTION FROM PRESCRIBED MESH POINTS
  $CHECK(MED1,1,'1\2',4)
  $IF(MED1=1) $MED2=0
  $HELP
    NUMBER OF RESETING SOLUTIONS
      MED2=0 - NO RESETING SOLUTIONS
      MED2=1 - FIRST NE SOLUTIONS RESETTED
      MED2=2 - FIRST NE SOLUTIONS INTERPOLATED
  $CHECK(MED2,0,'0\1\2',4)
  $HELP
    THE MAXIMUM NUMBER OF COLUMNS IN THE EXTRAPOLATION TABLE
  $CHECK(MED3,9,'3\4\5\6\7\8\9\10\11\12',4)
  $HELP
    CHOICE OF STEPSIZE SEQUENCE
  $CHECK(MED4,4,'1\2\3\4\5',4)
  $HELP
    THE DEGREE OF INTERPOLATION FORMULA
  $CHECK(MED5,4,'1\2\3\4\5\6',4)
  $IF (MED<2) $MED6=1
  $HELP
    NUMBER OF STEPS PRECEEDING TEST OF STIFTNESS
  $CHECK(MED6,0,'0\1',4,NO)
  $HELP
    MAXIMUM NUMBER OF INTEGRATION STEPS
  $CHECK(MSTP,100000,INT,3)
  $DIME='$MEL*($MED3+4)+5*$MED3+(2*$MED3*($MED3+2)+5)*$NE'
  $IF(MED<2) $DIME='$MEL*($MED3+4)+3*$MED3'
  $IF(MED=1)
    NAL=$NA
  $ENDIF
  $HELP
    PARAMETER FOR STEPSIZE CONTROL
  $CHECK(BET3,'4.0$P-2',REAL,4)
  $HELP
    PARAMETER FOR THE ORDER SELECTION
  $CHECK(TET1,'0.8$P 0',REAL,4)
  $HELP
    PARAMETER FOR THE ORDER SELECTION
  $CHECK(TET2,'0.9$P 0',REAL,4)
  $HELP
    INITIAL STEPSIZE
  $CHECK(HE,'0.0$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(HEMAX,'0.0$P 0',REAL,4)
  $HELP
    RELATIVE PRECISION
  $CHECK(TOLR,'1.0$P-6',REAL,3)
  $HELP
    ABSOLUTE PRECISION
  $CHECK(TOLA,'1.0$P-6',REAL,3)
  $HELP
    UPPER BOUND FOR SOLUTION NORM
  $CHECK(FMAX,'1.0$P 20',REAL,4)
  IF (NS.GE.2) THEN
    IF (TSS(NS).EQ.'UEDY') GO TO $10
  ENDIF
  CALL UEVEX1(NA,NAL,MAL,NE,MEL,KA,$AT,$AY,$YA,$YAO,$EF,$ES,$IES,L1&
,L2,$ETA0,$TET1,$TET2,TA,TAO,TAMAX,HE,HEMAX,FMAX,ERR,ERRO,MED,MED3&
,MED4,MED5,$MED6,NACC,NREJ,KAP,IER)
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$YAO($MEL)\$EF($MEL)&
  \$ES($DIME)')
  $ADD(INTEGER,'\$IES(2*$MED3+1)')
  $ADD(LOGICAL,'\L1,L2')
$REM  $ADD(REAL,'\TA\TAO\TAMAX\HE\HEMAX\FMAX\ERR')
$REM  $ADD(INTEGER,'\NA\MAL\MAL\NE\MEL\KA\NACC\NREJ\IER')
  GOTO ($LET,$LED,$10) ISB+1
$10 CONTINUE
  $SUBST('UEVEXA')
  GOTO ($LES,$LED) ISB+1
  $ADD(SINID)
    HEMAX=TAMAX-TA
  $ENDADD
  $ADD(INIT)
    NEDX='UEVEX1'
  $ENDADD
  $EXIT
