$INTERFACE ULLPF2                                             97/12/01
    $PAR=S
    $IF(JOB>0) $PAR=G
    $HELP
      TYPE OF EXTREMUM:
         0 - CHEBYSHEV APPROXIMATION
        -1 - MINIMAX
         1 - MAXIMIN
    $CHECK(IEXT,0,'-1\0\1',1)
    $HELP
      PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING
      SUBROUTINE
    $CHECK(EPS7,'1.0$P-8',REAL,4)
    $HELP
      TOLERANCE FOR ACTIVE CONSTRAINTS
    $CHECK(EPS9,'1.0$P-8',REAL,4)
    CALL ULLPF2(NF,N,MAL,MCL,$X,$IX,$IXA,$XN,$XO,$XL,$XU,$AF,$AFD,$IA&
,$IAA,$AG,$AR,$AZ,$CF,$CFD,$IC,$CL,$CU,$CG,$PAR,$S,$ETA9,EPS7,EPS9&
,XDEL,XNORM,UMAX,GMAX,$JOB)
    $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$XL($NF)\$XU($NF)&
    \$AG($NF*($MAL))\$AR(($NF+1)*($NF+2)/2)\$AZ($NF+1)\$CF($MCL)&
    \$CFD($MCL)\$CL($MCL)\$CU($MCL)\$CG($NF*$MCL)\$PAR($NF+1)&
    \$S($NF+1)')
$REM    $ADD(REAL,'\XDEL\XNORM\UMAX\GMAX\EPS7\EPS9')
$REM    $ADD(INTEGER,'\NF\N\MAL\MCL')
    $ADD(INTEGER,'\$IX($NX)\$IXA($NX)\$IAA($NF+1)\$IC($MCL)')
    $IF(IEXT=0)
      $ADD(REAL,'\$AF(2*$MAL)\$AFD(2*$MAL)')
      $ADD(INTEGER,'\$IA(2*$MAL)')
    $ELSE
      $ADD(REAL,'\$AF($MAL)\$AFD($MAL)')
      $ADD(INTEGER,'\$IA($MAL)')
    $ENDIF
    $ADD(INIT)
      NQPX='ULLPF2'
    $ENDADD
    $EXIT
